(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "User warnings - {{ config.name }}"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    ("class" "flex flex-col gap-2")
    (div
        ("class" "card-nest")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (span
                ("class" "flex items-center gap-2")
                (text "{{ icon \"gavel\" }}")
                (span
                    (text "{{ text \"mod_panel:label.create_warning\" }}")))
            (a
                ("href" "/mod_panel/profile/{{ profile.id }}")
                ("class" "button lowered small red")
                (text "{{ icon \"x\" }}")
                (span
                    (text "{{ text \"dialog:action.cancel\" }}"))))
        (form
            ("class" "card flex flex-col gap-2")
            ("onsubmit" "create_warning_from_form(event)")
            (div
                ("class" "flex flex-col gap-1")
                (label
                    ("for" "content")
                    (text "{{ text \"communities:label.content\" }}"))
                (textarea
                    ("type" "text")
                    ("name" "content")
                    ("id" "content")
                    ("placeholder" "content")
                    ("required" "")
                    ("minlength" "2")
                    ("maxlength" "4096")))
            (button
                ("class" "primary")
                (text "{{ text \"communities:action.create\" }}"))))
    (div
        ("class" "card-nest")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (span
                ("class" "flex items-center gap-2")
                (text "{{ icon \"message-circle-warning\" }}")
                (span
                    (text "{{ text \"mod_panel:label.warnings\" }}"))))
        (div
            ("class" "card flex flex-col gap-4")
            (text "{% for item in items %}")
            (div
                ("class" "card-nest")
                (div
                    ("class" "card small flex items-center justify-between gap-2")
                    (a
                        ("class" "flex items-center gap-2 flush")
                        ("href" "/api/v1/auth/user/find/{{ item.moderator }}")
                        ("title" "Moderator")
                        (text "{{ components::avatar(username=item.moderator, selector_type=\"id\") }}")
                        (span
                            (text "{{ item.moderator }}"))
                        (span
                            ("class" "fade date")
                            (text "{{ item.created }}")))
                    (button
                        ("class" "small lowered red")
                        ("onclick" "remove_warning('{{ item.id }}')")
                        (text "{{ icon \"trash\" }}")
                        (span
                            (text "{{ text \"general:action.delete\" }}"))))
                (div
                    ("class" "card secondary flex flex-col gap-2")
                    (span
                        ("class" "no_p_margin")
                        (text "{{ item.content|markdown|safe }}"))))
            (text "{% endfor %}")
            (text "{{ components::pagination(page=page, items=items|length) }}"))))

(script
    (text "async function create_warning_from_form(e) {
        e.preventDefault();
        await trigger(\"atto::debounce\", [\"warnings::create\"]);
        fetch(\"/api/v1/warnings/{{ profile.id }}\", {
            method: \"POST\",
            headers: {
                \"Content-Type\": \"application/json\",
            },
            body: JSON.stringify({
                content: e.target.content.value,
            }),
        })
            .then((res) => res.json())
            .then((res) => {
                trigger(\"atto::toast\", [
                    res.ok ? \"success\" : \"error\",
                    res.message,
                ]);

                if (res.ok) {
                    e.target.reset();
                }
            });
    }

    function remove_warning(id) {
        fetch(`/api/v1/warnings/${id}`, {
            method: \"DELETE\",
        })
            .then((res) => res.json())
            .then((res) => {
                trigger(\"atto::toast\", [
                    res.ok ? \"success\" : \"error\",
                    res.message,
                ]);
            });
    }"))

(text "{% endblock %}")
