(text "{%- import \"components.html\" as components -%} {%- import \"macros.html\" as macros -%}")
(text "<!doctype html>")

(html
    ("lang" "en")
    (head
        (meta ("charset" "UTF-8"))
        (meta ("name" "viewport") ("content" "width=device-width, initial-scale=1.0"))
        (meta ("http-equiv" "X-UA-Compatible") ("content" "ie=edge"))
        (meta ("http-equiv" "content-security-policy") ("content" "default-src 'self' blob: *.spotify.com musicbrainz.org; img-src * data:; media-src *; font-src *; style-src 'unsafe-inline' 'self' blob: *; script-src 'self' 'unsafe-inline' blob: *; object-src 'self' blob: *; upgrade-insecure-requests; connect-src * localhost; frame-src 'self' blob: data: *"))

        (link ("rel" "icon") ("href" "/public/favicon.svg"))
        (link ("rel" "stylesheet") ("href" "/css/style.css"))

        (text "{% if user -%}
        <script>
            window.localStorage.setItem(
                \"tetratto:theme\",
                \"{{ user.settings.theme_preference }}\",
            );
        </script>
        {%- endif %}")

        (text "<script>
            globalThis.ns_verbose = false;
            globalThis.ns_config = {
                root: \"/js/\",
                verbose: globalThis.ns_verbose,
                version: \"cache-breaker-{{ random_cache_breaker }}\",
            };

            globalThis._app_base = {
                name: \"tetratto\",
                ns_store: {},
                classes: {},
            };

            globalThis.no_policy = false;
        </script>")

        (script ("src" "/js/loader.js" ))
        (script ("src" "/js/atto.js" ))

        (meta ("name" "theme-color") ("content" "{{ config.color }}"))
        (meta ("name" "description") ("content" "{{ config.description }}"))
        (meta ("property" "og:type") ("content" "website"))
        (meta ("property" "og:site_name") ("content" "{{ config.name }}"))

        (meta ("name" "turbo-prefetch") ("content" "false"))
        (meta ("name" "turbo-refresh-method") ("content" "morph"))
        (meta ("name" "turbo-refresh-scroll") ("content" "preserve"))

        (script ("src" "https://unpkg.com/@hotwired/turbo@8.0.5/dist/turbo.es2017-esm.js") ("type" "module") ("async" "") ("defer" ""))

        (text "{% block head %}{% endblock %}"))

    (body
        (div
            ("id" "page")
            (text "{% if user and user.id == 0 -%}")
            ; account banned message
            (article
                (main
                    (div
                        ("class" "card-nest")
                        (div
                            ("class" "card small flex items-center gap-2 red")
                            (icon (text "frown"))
                            (str (text "general:label.account_banned")))

                        (div
                            ("class" "card")
                            (str (text "general:label.account_banned_body"))))))

            ; if we aren't banned, just show the page body
            (text "{% else %} {% block body %}{% endblock %} {%- endif %}")
            (text "<!-- html_footer_goes_here -->"))

        (text "{% include \"body.html\" %}")))
